// File: ReadFile.java

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class ReadFile extends Thread {
  private int id;
  private BufferedReader input;

  public ReadFile(String filename, int i) {
    id = i;
    try {
      input = new BufferedReader(new FileReader(filename));
    } catch(IOException e) {
      System.err.println(e);
      System.exit(-1);
    }
  }
  @Override
  public void run() {
    String line = null;
    int count = 0;
    try {
      while((line = input.readLine()) != null) {
        System.out.println("Object " + id + "->" + line);
        if ((++count % 5) == 0)
          Thread.yield();
      }
    } catch(IOException e) {
      System.err.println(e.getMessage());
      System.exit(-1);
    }
  }
}
