// File: Clock.java

public class Clock {
  private int hour;
  private int minute;
  private int second;
  private StringBuilder man;

  public Clock() {
  }

  public Clock(int h, int m, int s) {
    hour = h;
    minute = m;
    second = s;
    man = new StringBuilder("");
  }

  public StringBuilder getManufacturer() {
    return man;
  }

  public void setManufacturer(StringBuilder m) {
    m.append(" Corporation");
    man = m;
  }

  public int getHour() {
    return hour;
  }

  public void setHour(int h) {
    if (h > 12)
      h = 24 - h;
    hour = h;
  }

  public int getMinute() {
    return minute;
  }

  public void setMinute(int m) {
    minute = m;
  }

  public int getSecond() {
    return second;
  }

  public void setSecond(int s) {
    second = s;
  }

  public String toString() {
    return man + " " + hour + ":" + minute + ":" + second;
  }

  public boolean equals(Object obj) {
    if (this == obj)
      return true;

    if (obj != null && this.getClass() == obj.getClass()) {
      Clock c = (Clock) obj;

      return this.hour == c.hour &&
             this.minute == c.minute &&
             this.second == c.second &&
             this.man.toString().equals(c.man.toString());
    }
    return false;
  }

  protected void finalize() {
    System.out.println("finalize called");
  }
}