// File: MotionSensor.java

public class MotionSensor {
  private Switchable[] items;
  private int count = 0;
  private int timeoutMinutes = 10;

  public MotionSensor(int numItems) {
    items = new Switchable[numItems];
  }
  public void add(Switchable s) {
    if (count < items.length)
      items[count++] = s;
    //else throw exception
  }
  public void motionDetected() {
    System.out.println("Motion Detected");
    for ( Switchable item : items ) {
      if (item != null)
        item.turnOn();
    }
  }
  public void timeout() {
    // add code to determine if the proper amount of time has elapsed
    System.out.println("Timeout occurred");
    for ( Switchable item : items ) {
      if (item != null)
        item.turnOff();
    }
  }
  @Override
  public String toString() {
    StringBuilder builder = new StringBuilder();
    for ( Switchable item : items ) {
      if (item != null)
        builder.append(item.toString() + "\n");
    }
    return builder.toString();
  }
  public static void main(String[] args) {
    MotionSensor sensor = new MotionSensor(4);
    sensor.add(new IncandescentLamp());
    sensor.add(new HalogenLight());
    sensor.add(new GasFireplace());
    sensor.add(new Fan());
    // sensor.add(new Light());

    sensor.motionDetected();
    System.out.println(sensor);
    sensor.timeout();
    System.out.println(sensor);
  }
}