// File: Shoe.java

public class Shoe implements Comparable {
  private final int size;
  private final String brand;

  public Shoe (int size, String brand) {
    this.size = size;
    this.brand = brand;
  }

  public int getSize() {
    return size;
  }

  public String getBrand() {
    return brand;
  }

  @Override
  public String toString() {
    return "Size " + size + " " + brand;
  }

  public int compareTo(Object obj) {
    if (this == obj)
      return 0;

    if ((obj != null) && (obj instanceof Shoe)) {
      Shoe otherShoe = (Shoe) obj;

      if (this.size < otherShoe.size)
        return -1; // less than
      else if (this.size > otherShoe.size)
        return 1;  // greater than
      else
        return this.brand.compareTo(otherShoe.brand);
    }
    // if passed in object is null or not a Shoe, we'll
    // say its less than this Shoe
    return -1;
  }
}