// File: Order.java

import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.io.Serializable;

public class Order implements Serializable {
  private int custId;
  private String name;

  public Order(int id, String n) {
    custId = id;
    name = n;
  }
  public void writeText(String filename) {
    try {
      FileWriter foutput = new FileWriter(filename);
      PrintWriter pout= new PrintWriter(foutput);
      pout.print("ID: ");
      pout.println(custId);
      pout.print("Name: ");
      pout.print(name);
      pout.close();
    } catch (IOException e) {
      System.err.println(e);
    }
  }
  public void writeBinary(String filename) {
    try {
      FileOutputStream foutput = new FileOutputStream(filename);
      DataOutputStream doutput = new DataOutputStream(foutput);
      doutput.writeInt(custId);
      doutput.writeUTF(name);
      doutput.close();
    } catch (IOException e) {
      System.err.println(e);
    }
  }
  public void writeObj(String filename) {
    try {
      FileOutputStream fout = new FileOutputStream(filename);
      ObjectOutputStream out = new ObjectOutputStream(fout);
      out.writeObject(this);
      out.close();
    }  catch (IOException e) {
      System.err.println(e);
    }
  }
  public static void main(String[] args) {
    Order o = new Order(23, "Bob Dobbs");
    o.writeText("order.txt");
    o.writeBinary("order.dat");
    o.writeObj("order.ser");
  }
}


