// File: Search2.java

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class Search2 {
  public static void main(String[] args) {
    if (args.length < 2) {
      System.err.println("Usage: java Search2 {pattern} {file}");
      System.exit(1);
    }

    String line;
    String pattern = args[0];
    String filename = args[1];

    try {
      FileReader fin = new FileReader(filename);
      BufferedReader bufin = new BufferedReader(fin);

      while ((line = bufin.readLine()) != null) {
        if (line.indexOf(pattern) >= 0) {
          // matched
          System.out.println(line);
        }
      }
    } catch(IOException e) {
      System.err.println(e);
    }
  }
}